var dllCLSID = "{25815CC0-43F4-3C75-8C3A-A139D9ADE740}";

var currentNIC = 0;			// the NIC we're displaying
var resetEvery = 10;		// reset the max value of the graph every n secs
var barWidth = 216;			// the max width of the bars
var maxHistory = 11;		// the maximum number of reading we should keep for the history
var refreshRate = 1000;		// time in ms between updates

var scaleTo;				// the bandwidth to scale the bar too
var scaleToGraph;			// the bandwidth to scale the graph too
var resetCounter;			// counter used to reset the graphs
var xOffset;				// used to scale the graph
var scaleDocked = 0.5;		// scale of the Gadget when docked
var scaleUndocked = 1.0;	// scale of the Gadget when undocked
var gWidth = 260;			// gadget width
var gHeight = 152;			// gadget height

var NICbytesReceived, NICbytesSent, NICbandwidth, NICdescription, NICcount, tRefresh;

var history = new Array();
var gadgetPath = System.Gadget.path;
var charbackslash = new RegExp("\\\\", "g");

var oShell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");


System.Gadget.onDock = dockedState;
System.Gadget.onUndock = dockedState;
System.Gadget.settingsUI = "Settings.html";


var bDebug = oFSO.FileExists(gadgetPath+"\\debug.txt");
try{
	if (bDebug)
		var debugLogFile = oFSO.OpenTextFile(gadgetPath+"\\debug.txt", 2);
} catch(err) {bDebug = false; debugLog("Open debug.txt error"+err.name+" - "+err.message)}

var NetLib, regRoot;

//register network library
if(bDebug) debugLog("Register ActiveX");
if(bDebug) debugLog("trying HKCU");
if (!activeDLL("HKCU")) {
	if(bDebug) debugLog("trying HKLM");
	if (!activeDLL("HKLM"))
		debugLog("Error creating DSXLib ActiveX object");
}


function dockedState() {
//// Workaround bug#30 (http://www.aeroxp.org/board/index.php?showtopic=7318)
	if (parseInt(document.body.currentStyle["width"]) == parseInt(System.Gadget.docked ? gWidth*scaleDocked : gWidth*scaleUndocked)) return;
////
	System.Gadget.beginTransition();
	
	if (System.Gadget.docked) {
		document.body.style.width = gWidth*scaleDocked;
		document.body.style.height = gHeight*scaleDocked;
		var strokeweight = 1 + 0.5*(scaleDocked-0.5);
	} else {
		document.body.style.width = gWidth*scaleUndocked;
		document.body.style.height = gHeight*scaleUndocked;
		var strokeweight = 1 + 0.5*(scaleUndocked-0.5);
	}

	graphReceived.strokeweight = strokeweight;
	graphSent.strokeweight = strokeweight;

	window.setTimeout(setZoom, 400);
	System.Gadget.endTransition(System.Gadget.TransitionType.morph, 0.2);
}

function setZoom() {
	if (System.Gadget.docked)
		document.body.style.zoom = scaleDocked;
	else
		document.body.style.zoom = scaleUndocked;
}



function startUpGadget() {
	System.Gadget.background = "images/background.png";
	dockedState();

	updateNICdetails();
	initNIC();
	
	if (bDebug && currentNIC != -1) {
		debugLog("Current NIC is: " + NICdescription);
		debugLog("NIC bandwidth (bytes/sec): " + parseInt(NetLib.Speed(currentNIC))/8);
		debugLog("Scale capped at (bytes/sec): " + NICbandwidth);
		debugLog("Update Interval (ms): " + refreshRate);
	}
}


function updateNICdetails() {
	try{
		//get the NIC's
		NICcount = NetLib.Initialize();
	} catch (err) {debugLog("Can't initialize NetLib: "+err.name+ " - "+err.message)}
}


function initNIC(checkAvailability) {
	if (!checkAvailability)
		try{window.clearTimeout(tRefresh)} catch(err) {debugLog("Cancel timer: "+err.name+ " - "+err.message)}

	try{
		//read the settings
		if (System.Gadget.Settings.readString("scaleDocked") != "")
			scaleDocked = parseInt(System.Gadget.Settings.readString("scaleDocked"))/100;
		if (System.Gadget.Settings.readString("scaleUndocked") != "")
			scaleUndocked = parseInt(System.Gadget.Settings.readString("scaleUndocked"))/100;

		if (System.Gadget.Settings.readString("CurrentNIC") != "") {
			var tmpNICdesc = System.Gadget.Settings.readString("CurrentNIC");
			currentNIC = -1;
			// search for the correct NIC
			try{
				for (var i=0; i < NICcount; i++) {
					if (NetLib.Description(i) == tmpNICdesc)
						currentNIC = i;
				}
			} catch(err) {}	// handle the NIC count changing

			// if we didn't find it, notify the user
			if (currentNIC == -1) {
				if (divUnavailable.style.display != "inline") {
					if (bDebug) debugLog("NIC unavailable (" + NICdescription + ")");
					dockedState();
					divBars.style.display = "none";
					divGraph.style.display = "none";
					divUnavailable.style.display = "inline";
					
					//setup the update timer
					try{window.clearTimeout(tRefresh)} catch(err) {debugLog("Cancel timer: "+err.name+ " - "+err.message)}
					tRefresh = window.setInterval(displayStats, 1000);
				}
				return;
			} else {
				if (divUnavailable.style.display == "inline" && bDebug) debugLog("NIC available (" + NICdescription + ")");

				dockedState();
				divUnavailable.style.display = "none";

				if (System.Gadget.Settings.read("Display") == "Bar")
					divBars.style.display = "inline";
				else
					divGraph.style.display = "inline";

				try{window.clearTimeout(tRefresh)} catch(err) {debugLog("Cancel timer: "+err.name+ " - "+err.message)}
			}
		}

		//get the current NIC info
		NICbytesReceived = parseInt(NetLib.BytesReceived(currentNIC));
		NICbytesSent = parseInt(NetLib.BytesSent(currentNIC));
		NICdescription = NetLib.Description(currentNIC);

		//if we're just checking if the NIC has come back online, we don't need to change any of this
		if (!checkAvailability) {
			if (System.Gadget.Settings.readString("ResetEvery") != "")
				resetEvery = parseInt(System.Gadget.Settings.readString("ResetEvery"));
			if (System.Gadget.Settings.readString("MaxHistory") != "")
				maxHistory = parseInt(System.Gadget.Settings.readString("MaxHistory"));
			if (System.Gadget.Settings.readString("RefreshRate") != "")
				refreshRate = parseInt(System.Gadget.Settings.readString("RefreshRate"));
	
			if (resetEvery == 0) {
				if (System.Gadget.Settings.readString("NICbandwidth") != "") {
					NICbandwidth = System.Gadget.Settings.read("NICbandwidth")*125;
					scaleTo = NICbandwidth;
					scaleToGraph = NICbandwidth;
				} else {
					NICbandwidth = parseInt(NetLib.Speed(currentNIC))/8;
					scaleTo = 0;
					scaleToGraph = 0;
				}
			} else {
				NICbandwidth = parseInt(NetLib.Speed(currentNIC))/8;
				scaleTo = 0;
				scaleToGraph = 0;
			}
	
			resetCounter = 0;
		
			xOffset = 1000/(maxHistory - 1);
	
			//initialise the history
			history = new Array(maxHistory);
			for (var i=0; i<maxHistory; i++)
				history[i] = [0,0];
	
			displayStats();
		}

		//setup the update timer
		tRefresh = window.setInterval(displayStats, refreshRate);

	} catch (err) {debugLog("Can't read NIC: "+err.name+ " - "+err.message)}
}


// Register NetLib ActiveX component
function RegisterNetLib() {
	var classRoot = regRoot + "\\Software\\Classes\\NICGadget.NetworkInformation\\";
	var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + dllCLSID + "\\";

	try{
		oShell.RegWrite(classRoot,"NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(classRoot + "CLSID\\", dllCLSID, "REG_SZ");
		oShell.RegWrite(clsidRoot, "NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\", "mscoree.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\ThreadingModel", "Both", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Class", "NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\Assembly", "NetLib, Version=1.0.2588.9125, Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\RuntimeVersion", "v2.0.50727", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\CodeBase", "file:///" + gadgetPath.replace(charbackslash, "/") + "/netlib.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\Class", "NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\Assembly", "NetLib, Version=1.0.2588.9125, Culture=neutral, PublicKeyToken=null", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\RuntimeVersion", "v2.0.50727", "REG_SZ");
		oShell.RegWrite(clsidRoot + "InprocServer32\\1.0.2588.9125\\CodeBase", "file:///" + gadgetPath.replace(charbackslash, "/") + "/netlib.dll", "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\", "NICGadget.NetworkInformation", "REG_SZ");
		oShell.RegWrite(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\", "", "REG_SZ");
	} catch(err) {debugLog("RegisterNetLib: "+err.name+" - "+err.message)}
}


function terminate() {
	try{NetLib.Terminate()} catch(err) {debugLog("Can't dispose of NetLib variables")}

	NetLib = null;

	UnregisterNetLib();
}


// Unregister DirectSound ActiveX component
function UnregisterNetLib() {
	var classRoot = regRoot + "\\Software\\Classes\\NICGadget.NetworkInformation\\";
	var clsidRoot = regRoot + "\\Software\\Classes\\CLSID\\" + dllCLSID + "\\";

	try{		
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\{62C8FE65-4EBB-45E7-B440-6E39B2CDBF29}\\");
		oShell.RegDelete(clsidRoot + "ProgId\\Implemented Categories\\");
		oShell.RegDelete(clsidRoot + "ProgId\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\1.0.2588.9125\\");
		oShell.RegDelete(clsidRoot + "InprocServer32\\");
		oShell.RegDelete(clsidRoot);
		oShell.RegDelete(classRoot + "CLSID\\");
		oShell.RegDelete(classRoot);
	} catch(err) {debugLog("UnregisterNetLib: "+err.name+" - "+err.message)}
}



// Try to register the DLL
function activeDLL(root) {
	regRoot = root;

	try{
		RegisterNetLib();
		NetLib = new ActiveXObject("NICGadget.NetworkInformation");
	} catch(err) {
		NetLib = null;
		UnregisterNetLib();
		return false;
	}
	return true;
}



//log a debug entry
function debugLog(str) {
	try{
		System.Debug.outputString(str);
		if (bDebug)
			debugLogFile.WriteLine(str);
	} catch(err) {}
}



function displayStats() {
	if (!System.Gadget.visible) return;

	// update the NIC's to see if the current NIC is available
	updateNICdetails();
	try{
		if (NetLib.Description(currentNIC) != NICdescription)
			currentNIC = -1;
	} catch(err) {
		currentNIC = -1;
	}
	
	// is the NIC unavailable
	if (currentNIC == -1) {
		// check it again
		initNIC(true);
		if (currentNIC == -1)
			return;
	}
try{
	// update the max throughput to handle WiFi cards, if scale is set to auto
	if (resetEvery != 0) {
		var newBandwidth = parseInt(NetLib.Speed(currentNIC))/8;
		if (bDebug && newBandwidth != NICbandwidth) debugLog("NIC Bandwidth changed to: " + newBandwidth + " bytes/sec");
		NICbandwidth = newBandwidth;
	}

	var bytesReceived = parseInt(NetLib.BytesReceived(currentNIC));
	var bytesSent = parseInt(NetLib.BytesSent(currentNIC));
	var intervalDivisor = refreshRate/1000;
	var bytesReceivedPerSec = parseInt((bytesReceived - NICbytesReceived) / intervalDivisor);
	var bytesSentPerSec = parseInt((bytesSent - NICbytesSent) / intervalDivisor);

	// account for the machine being in hibernation
	if (bytesReceivedPerSec < 0) bytesReceivedPerSec = 0;
	if (bytesSentPerSec < 0) bytesSentPerSec = 0;

	//update bar
	var sentKB = parseInt(bytesSentPerSec/1024);
	var receivedKB = parseInt(bytesReceivedPerSec/1024);

	//if (bDebug) debugLog("NIC received KB/interval: " + receivedKB);
	//if (bDebug) debugLog("NIC sent KB/interval: " + sentKB);

	divReceived.innerText = divReceived2.innerText = (receivedKB > 1024) ? fixValue(String(receivedKB/1024).substring(0,4)) + " MB" : receivedKB + " KB";
	divSent.innerText = divSent2.innerText = (sentKB > 1024) ? fixValue(String(sentKB/1024).substring(0,4)) + " MB" : sentKB + " KB";

	// cap the values
	if (resetEvery == 0) {
		if (bytesReceivedPerSec>NICbandwidth) bytesReceivedPerSec = NICbandwidth;
		if (bytesSentPerSec>NICbandwidth) bytesSentPerSec = NICbandwidth;
	}

	NICbytesReceived = bytesReceived;
	NICbytesSent = bytesSent;

	// add the values to the history array
	if (history.push([bytesReceivedPerSec, bytesSentPerSec]) > maxHistory)
		var tmp = history.shift();

	//should we reset the scale
	if (resetEvery > 0)
	{
		if (resetCounter++ == resetEvery)
		{
			scaleTo = 0;
			scaleToGraph = 0;
			resetCounter = 0;
			for (var i=0; i<maxHistory; i++)
			{
				if (history[i][0] > scaleToGraph) scaleToGraph = history[i][0];
				if (history[i][1] > scaleToGraph) scaleToGraph = history[i][1];
			}
		}
		if (scaleTo < bytesReceivedPerSec) scaleTo = bytesReceivedPerSec;
		if (scaleTo < bytesSentPerSec) scaleTo = bytesSentPerSec;
		if (scaleTo < NICbandwidth/100) scaleTo = NICbandwidth/100;

		if (scaleToGraph < history[maxHistory-1][0]) scaleToGraph = history[maxHistory-1][0];
		if (scaleToGraph < history[maxHistory-1][1]) scaleToGraph = history[maxHistory-1][1];
		if (scaleToGraph < NICbandwidth/100) scaleToGraph = NICbandwidth/100;
	}

	barReceived.style.width = parseInt(barWidth / (scaleTo / bytesReceivedPerSec));
	barSent.style.width = parseInt(barWidth / (scaleTo / bytesSentPerSec));
	scaleText(divScale, scaleTo);

	//update graph
	if (maxHistory < 120) {
		var pathReceived = "m 0," + (1000 - parseInt(1000 / (scaleToGraph / history[0][0]))) + " l";
		var pathSent = "m 0," + (1000 - parseInt(1000 / (scaleToGraph / history[0][1]))) + " l";
		for (var i=1; i<maxHistory; i++)
		{
			if (history[i][0] > 0)
				pathReceived += " " + parseInt(i*xOffset) + "," + (1000 - Math.round(1000 / (scaleToGraph / history[i][0])));
			else
				pathReceived += " " + parseInt(i*xOffset) + ",1000";
			
			if (history[i][1] > 0)
				pathSent += " " + parseInt(i*xOffset) + "," + (1000 - Math.round(1000/ (scaleToGraph / history[i][1])));
			else
				pathSent += " " + parseInt(i*xOffset) + ",1000";

			if (i<maxHistory - 1)
			{
				pathReceived += ",";
				pathSent += ",";
			}
		}
	} else {
		var pathReceived = "";
		var pathSent = "";
		for (var i=0; i<maxHistory; i++)
		{
			if (history[i][0] > 0) {
				pathReceived += "m " + parseInt(i*xOffset) + ",1000 ";
				pathReceived += "l " + parseInt(i*xOffset) + "," + (1000 - Math.round(1000 / (scaleToGraph / history[i][0]))) + " ";
			}
			if (history[i][1] > 0) {
				pathSent += "m " + parseInt(i*xOffset) + ",1000 ";
				pathSent += "l " + parseInt(i*xOffset) + "," + (1000 - Math.round(1000/ (scaleToGraph / history[i][1]))) + " ";
			}
		}
	}
	graphReceived.path = pathReceived + " e"
	graphSent.path = pathSent + " e"
	scaleText(divScale2, scaleToGraph);
} catch(err) {debugLog("displayStats: "+err.name+" - "+err.message)}
}



function scaleText(obj, value) {
try{
	var tmp = value/1024;
	var str = (tmp>1024) ? fixValue(String(tmp/1024).substring(0,4)) + " MB" : parseInt(tmp) + " KB";
	
	if (value != NICbandwidth) {
		tmp = NICbandwidth/1024;
		obj.title = str + " / " + ((tmp>1024) ? fixValue(String(tmp/1024).substring(0,4)) + " MB" : parseInt(tmp) + " KB");
	} else
		obj.title = str;

	obj.innerText = Math.round((value / NICbandwidth)*100) + "%";
} catch(err) {debugLog("scaleText: "+err.name+" - "+err.message)}
}


function fixValue(sValue) {
	if (sValue.substring(sValue.length-1) == ".")
		return sValue.substring(0, sValue.length - 1);
	else
		return sValue;
}


function switchDisplay() {
try{
	if (divGraph.style.display == "none")
	{
		divGraph.style.display = "inline";
		divBars.style.display = "none";
		System.Gadget.Settings.write("Display", "Graph");
	} else {
		divGraph.style.display = "none";
		divBars.style.display = "inline";
		System.Gadget.Settings.write("Display", "Bar");
	}
} catch(err) {debugLog(err.name+" - "+err.message)}
}